;;draw the stair in 3D space with command "3dstair"
(defun c:3dstair ()

(recolha_dados)
(escolha)

;;draw the first staircase
	;;preposition

	;;complete information 
		(setq p2 (list (car p1) (+ (cadr p1) riser) (caddr p1)))
		(setq p3 (list (+ (car p2) tread) (cadr p2) (caddr p1)))
		(setq p9 (list (+ (car p3) tread) (cadr p3)))
		(setq p10 (list (car p3) (- (cadr p3) riser)))
		(setvar "osmode" 0)

	;;draw the step	
   		(command "_.pline" p1 p2 p9 p10 "_c")
		(command "_.extrude" "_last" "" width)
		
	;;insert more steps
		(repeat (- n_steps 1)
		(command "_.copy" "_last" "" p1 p3) ) 


;;draw the landing
	;;complete information
		(setq p4 (list (+ (car p1) (* tread n_steps)) (+ (cadr p1) (* riser n_steps))(caddr p1)))
		(setq p5 (list (+ (car p4) (* tread 3)) (+ (cadr p4) riser)))

	;;draw the landing
   		(command "_.rectang" p4 p5)
		(command "_.extrude" "_last" "" (+ (* width 2) gap))

;;draw the second staircase
	;;complete information
		(setq p6 (list (car p4) (+ (cadr p4) riser) (+ (caddr p4) width gap)))

		(setq p7 (list (car p6) (+ (cadr p6) riser) (+ (caddr p4) width gap)))
		(setq p8 (list (- (car p7) tread) (cadr p7) (+ (caddr p4) width gap)))
		(setq p11 (list (car p6) (- (cadr p6) riser) (+ (caddr p4) width gap)))
		(setq p12 (list (car p8) (- (cadr p8) riser) (+ (caddr p4) width gap)))
		
		
	;;draw the step	
   		(command "_.pline" p6 p7 p8 p12 p11 "_c")
		(command "_.extrude" "_last" "" width)
		
	;;insert more steps
		(repeat (- n_steps 1)
		(command "_.copy" "_last" "" p6 p8) ) 

;; handrail		
		(setq p13 (list (+ (car p2) (/ tread 2)) (cadr p2) (+ (caddr p2) width)))
		(command "_.line" p13 (list (car p13) (+ (cadr p13) hand) (caddr p13)) "")

		(setq p14 (list (+ (car p4) (/ tread 2)) (+ (cadr p4) riser) (+ (caddr p4) width)))
		(command "_.line" p14 (list (car p14) (+ (cadr p14) hand) (caddr p14)) "")
		
		(setq p15 (list (car p14) (cadr p14) (+ (caddr p14) gap)))
		(command "_.line" p15 (list (car p15) (+ (cadr p15) hand) (caddr p15)) "")		

		(setq p16 (list (car p13) (+ (cadr p13) (* riser (* 2 n_steps))) (caddr p15)))
		(command "_.line" p16 (list (car p16) (+ (cadr p16) hand) (caddr p16)) "")	

(reposicao_dados)
)

(defun entrada_dados_p ()
	(command "_vpoint" (list 1 1 1))
	(command "_ucs" "_x" 90 )
		(setq p1 (getpoint "\n Indique o ponto de arranque da escada de dois lances: "))
		(setq p1  (list (car p1) 0 (caddr p1)))
		(setq riser (getreal "\n Indique a altura do espelho: "))
		(setq tread (- 0.64 (* riser 2)))
		(setq n_steps (getint "\nDiga quantos degraus tem cada lance: " ))
		(setq width (getreal "\n Indique a largura do lance: "))
		(setq gap (getreal "\n Indique a largura da bomba da escada: "))
		(setq hand (getreal "\n Defina a altura do corrimÃ£o:  "))
	)


(defun entrada_dados_i ()
	(command "_vpoint" (list 1 1 1))
	(command "_ucs" "_x" 90 )
	;;ask for information from user
	
		(setq p1 (getpoint "Insert the starting point of the stair of two runs: "))
		(setq p1  (list (car p1) 0 (caddr p1)))
		(setq riser (getreal "\n Give the riser of the step: "))
		(setq tread (- 0.64 (* riser 2)))
		(setq n_steps (getint "\n Give the number of steps: " ))
		(setq width (getreal "\n Give the width of each run: "))
		(setq gap (getreal "\n Give the width of the gap between runs: "))
		(setq hand (getreal "\n Define the handrail height:  "))
	)
	
(defun recolha_dados ()
;;prepair the control of osnap
    (setq pontoS2d (getvar "osmode"))
	(setq pontoS3d (getvar "3dosmode"))
	(setq eco (getvar "CMDECHO"))
	(setvar "3dosmode" 0)
	(setvar "osmode" 1)
	(setvar "CMDECHO" 0)

)
(defun reposicao_dados ()
;;resume the values for the osnap variables	
	(command "_.ucs" "" "")	
	(setvar "3dosmode" pontoS3d)
	(setvar "osmode" pontoS2d)
	(setvar "CMDECHO" eco)
	(princ)(princ)
)

(defun escolha ()

(if (= "p" (getstring "Language: p or i? ")) (entrada_dados_p) (entrada_dados_i))
)